package webppclient;

import java.net.*;
import java.io.*;
import java.util.*;


///////////////////////////////////////////////////////////////////////////////
// 
// statistics for a single document lookup
//
///////////////////////////////////////////////////////////////////////////////
final class StatMoments
{
    // returns a requested percentile =========================================
    double getPercentile( double perc, int sampleSize )
        throws Exception
    {
        double k;

        Assert.assert( sampleSize > 0, Integer.toString(sampleSize) );

        if ( perc == 50 ) {
            k = 0.;
        } else if ( perc == 55 ) {
            k = 0.126;
        } else if ( perc == 60 ) {
            k = 0.253;
        } else if ( perc == 65 ) {
            k = 0.385;
        } else if ( perc == 70 ) {
            k = 0.524;
        } else {
            throw new Exception( "incorrect value of percentile: " + perc );
        }   

        return avg + k * stdDev / Math.sqrt( (double)sampleSize );
    }
  
    // data members ===========================================================
    double avg;           // average 
    double stdDev;        // standard deviation
}


