package webppserv;

import java.io.*;
import java.lang.*;
import java.util.*;

class MessageBroadcaster extends Thread implements Runnable
{
  String msgType, param, recipients;
  boolean useURLforParams;

  public MessageBroadcaster(String msgType, String param)
  {
	this.msgType = msgType;
	this.param = param;
	this.recipients = "Servers";
	this.useURLforParams = true;
  }

  public MessageBroadcaster(String msgType, String param, String recipients)
  {
        this.msgType = msgType;
        this.param = param;
        this.recipients = recipients;
	this.useURLforParams = true;
  }

  public MessageBroadcaster(String msgType, String param, boolean useURL)
  {
	this.msgType = msgType;
        this.param = param;
        this.recipients = "Servers";
	this.useURLforParams = useURL;
  }

  public MessageBroadcaster(String msgType, String param, String recipients,
							boolean useURL)
  {
	this.msgType = msgType;
        this.param = param;
        this.recipients = recipients;
        this.useURLforParams = useURL;
  }

  public void run()
  {
	String serverName, port;
        Enumeration enum;
        ThreadGroup msgTG    = new ThreadGroup("Message Group");

	try { setPriority(MIN_PRIORITY); } catch (Exception ee) {}
	yield();	// give the caller a chance to go on

	if (msgType == null || param == null) {
	  System.out.println("Error: an argument is null in MessageBroadcaster:run");
	  return;
	}

	Webpp.msgCount = 0;
	if (recipients.equalsIgnoreCase("Servers"))
          enum = Webpp.serverPorts.keys();
	else
	  enum = Webpp.clientPorts.keys();
        while( enum.hasMoreElements() ) {
          serverName = (String) enum.nextElement();
	  //System.out.println("Before bcast to " + serverName);
          if (serverName == null) return;
          if (serverName.equals(Webpp.server) || 
		(recipients.equalsIgnoreCase("Servers") &&
		!Webpp.serverIsAlive(serverName)) /* ||
		(recipients.equalsIgnoreCase("Clients") &&
		!Webpp.clientIsAlive(serverName)) */ )
	  {
	    continue;  		// don't send messages to yourself or dead servers or dead clients
	  }
	  if (recipients.equalsIgnoreCase("Servers"))
	    port = (String) Webpp.serverPorts.get(serverName);
	  else
	    port = (String) Webpp.clientPorts.get(serverName);
	  //System.out.println("Sending bcast to " + serverName + " : " + msgType + " - " + param);
          Runnable r = new SendMsg(serverName + ":" + port, msgType, param, recipients, useURLforParams);
          Thread t = new Thread(msgTG, r);
          t.start();
          Webpp.msgCount++;
        }
        while (Webpp.msgCount > 0) {
	  try {
	    sleep(100);
	  } catch (InterruptedException ie) {}
	}

        System.out.println("Broadcast to " + recipients + " is finished for " + msgType);
  }

}
