package webppserv;

import java.io.*;
import java.lang.*;
import java.net.*;

class SendMsg extends Thread
{
  String serverName, msgType, param, recipients;
  boolean useURLforParams;

  public SendMsg(String serverName, String msgType, String param, String recipients, boolean useURL) {
    this.serverName = serverName;
    this.msgType = msgType;
    this.param = param;
    this.recipients = recipients;
    this.useURLforParams = useURL;
  }

 public SendMsg(String serverName, String msgType, String param, boolean useURL) {
    this.serverName = serverName;
    this.msgType = msgType;
    this.param = param;
    this.recipients = "Servers";
    this.useURLforParams = useURL;
  } 

  public void run() {
    try { setPriority(MIN_PRIORITY); } catch (Exception ee) {}
    yield();	// give the caller a chance to go on
    try {
      postURL(serverName, msgType, param, recipients, useURLforParams);
    } catch (Exception e) {
      System.out.println("Problem while sending " +  msgType + " message to " + serverName);
    }
    Webpp.msgCount--;
  }

  public static void postURL(String serverName, String msgType, String param,
		String recipients, boolean useURL) throws Exception
  {
    byte b = 0;
    int done = 0, bytesRead;
    String urlName = null, servletStr = "webppserv";
    InputStream tmpin;

    if (recipients.equalsIgnoreCase("Clients"))
      servletStr = "webppclient";
    if (param == null || !useURL)
      urlName = "http://" + serverName + "/servlet/" + servletStr + ".Webpp/?" + msgType;
    else
      urlName = "http://" + serverName + "/servlet/" + servletStr + ".Webpp/?" + msgType + "&" + param;
    URL url = new URL(urlName);
    HttpURLConnection conn = (HttpURLConnection) url.openConnection();
    
    conn.setRequestMethod("POST");
    bytesRead = 0;

    // Send your Post message
    if (param != null)
      conn.setRequestProperty("param", param);

    // Get the response
    tmpin = conn.getInputStream();
    if (tmpin == null) return;
    DataInputStream in = new DataInputStream(tmpin);
    if (in == null) return;
    try { b = in.readByte(); } catch (EOFException e) { done = 1; }
    while (done == 0) {
      bytesRead++;
      try { b = in.readByte(); } catch (EOFException e) { done = 1; }
    }
    in.close();
  }

}
