
import java.net.*;
import java.io.*;
import java.util.*;
import java.lang.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.oreilly.servlet.*;

public class UploadServlet2 extends HttpServlet 
{
    String reqType;

    protected void doGet( HttpServletRequest req,
                          HttpServletResponse resp ) 
        throws ServletException, IOException
    {
	System.out.println("Upload GET");
        reqType = "GET";
	String qry = req.getQueryString();
        if (qry.equals("destroy")) destroyServer();
	else if (qry.startsWith("delete=")) {
	  int pos = qry.indexOf('=');
	  if (pos < 0) {
	    System.out.println("Error: delete request does not include file name!");
	    return;
	  }
	  String delFile = qry.substring(pos+1);
	  deleteFile(delFile);
	}
    }

    protected void doPut( HttpServletRequest req,
                          HttpServletResponse resp )
        throws ServletException, IOException
    {
        ServletInputStream reader = null;
        FileOutputStream store = null;
        String qry = null;
        byte buffer[] = new byte[4096];
        int len = 0;
        int bytesRead = 0;

	System.out.println("Upload PUT");
	reqType = "PUT";

        // get qry string
	qry = req.getQueryString();
	if( qry == null ){
	    //resp.sendError( HttpServletResponse.SC_NOT_FOUND,
	    //                    "no query string received" );
	    //return;
          qry = "test2.html";
	}

        // open the stream to read the file to replicate
        reader = req.getInputStream();

        try {
            store  = new FileOutputStream( qry );
        } catch( IOException e ){
            resp.sendError( HttpServletResponse.SC_NOT_FOUND,
                            "could not open store file " + qry );
        }

        // store the file
        while( (len = reader.read( buffer )) != -1 ){
            store.write( buffer, 0, len );
            System.out.println("Len: " + len);
	    bytesRead += len;
        }
        store.close();

        PrintWriter out = resp.getWriter();
	out.println("Uploaded file: " + qry );
	out.close();
       
        resp.setStatus( HttpServletResponse.SC_OK,
                        "Uploaded file: " + qry );
	System.out.println("Uploaded file: " + qry + " size: " + bytesRead);
    }

    protected void doPost( HttpServletRequest req,
                           HttpServletResponse resp )
        throws ServletException, IOException
    {
        ServletInputStream reader = null;
        FileOutputStream store = null;
        String qry = null;
        byte buffer[] = new byte[4096];
        int len = 0;

	System.out.println("Upload POST");
	reqType = "POST";

        //displayHeaders(req);

        qry = req.getQueryString();
        if (qry == null)
          doMultipartRequest(req, resp);
        else {
	  if (qry.equals("destroy")) destroy();
	  else doSinglePartRequest(req, resp);
        }
    }

    protected void doMultipartRequest( HttpServletRequest req,
                           HttpServletResponse resp )
        throws ServletException, IOException
    {
	MultipartRequest multi = new MultipartRequest(req, ".");
	System.out.println("Params:");
	Enumeration params = multi.getParameterNames();
	while (params.hasMoreElements()) {
	  String name = (String)params.nextElement();
	  String value = multi.getParameter(name);
	  System.out.println(name + " = " + value);
	}
	System.out.println();
	System.out.println("Files:");
	Enumeration files = multi.getFileNames();
	while (files.hasMoreElements()) {
	  String name = (String)files.nextElement();
	  String filename = multi.getFilesystemName(name);
	  String type = multi.getContentType(name);
	  File f = multi.getFile(name);
	  System.out.println("name: " + name);
	  System.out.println("filename: " + filename);
	  System.out.println("type: " + type);
	  if (f != null) {
	    System.out.println("f.toString(): " + f.toString());
	    System.out.println("f.getName(): " + f.getName());
	    System.out.println("f.exists(): " + f.exists());
	    System.out.println("f.length(): " + f.length());
 	    System.out.println();
	  }
	}
    }

    protected void doSinglePartRequest( HttpServletRequest req,
                           HttpServletResponse resp )
        throws ServletException, IOException
    {
        ServletInputStream reader = null;
        FileOutputStream store = null;
        String qry = null;
        byte buffer[] = new byte[4096];
        int len = 0;
        String path;

        // get qry string
	qry = req.getQueryString();
	if( qry == null ){
	    //resp.sendError( HttpServletResponse.SC_NOT_FOUND,
	    //                    "no query string received" );
	    //return;
          String [] qry2 = req.getParameterValues("upload");
          if( qry2 == null ) {
            //resp.sendError( HttpServletResponse.SC_NOT_FOUND,
	    //			"no query string received" );
	    //return;
	    qry = "te jjjst3.txt";
          }
          else qry = qry2[1];
	}

        path = req.getHeader("path");

        System.out.println("File: " + qry + " Path: " + path);
        if (path != null) qry = path + qry;

        // open the stream to read the file to replicate
        reader = req.getInputStream();
        try {
            store  = new FileOutputStream( qry );

        } catch( IOException e ){
            resp.sendError( HttpServletResponse.SC_NOT_FOUND,
                            "could not open store file " + qry );
        }

        // store the file
        while( (len = reader.read( buffer )) != -1 ){
            store.write( buffer, 0, len );
            System.out.println("Len: " + len);
        }
        store.close();
       
        resp.setStatus( HttpServletResponse.SC_OK,
                        "uploaded file " + qry );
	System.out.println("Uploaded file: " + qry);
    }

    void displayHeaders(HttpServletRequest req)
    {
        // Begin Mehmet: debug headers
        Enumeration reqHeaders = req.getHeaderNames();
        while (reqHeaders != null && reqHeaders.hasMoreElements()) {
          String headerStr = ((String) reqHeaders.nextElement());
          String valueStr = null;
          if (headerStr != null)
            valueStr = req.getHeader(headerStr);
          if (headerStr != null && valueStr != null)
            System.out.println("Header: " + headerStr + " : " + valueStr);
        }
        // End Mehmet: debug headers
    }

    public void destroyServer() {
	System.out.println("Destroying");
	System.exit(1);
    }

    public void deleteFile(String fname) {
	System.out.println("Deleting " + fname);
	File fd = new File(fname);
	try { fd.delete(); } catch (SecurityException e) {
	  System.out.println("Error: cannot delete " + fname);
	  return;
	}
    }

}
